package com.example.mynotepad.MenuFeatures.Calender.MyCalenderRecyclerView.TimePicker;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.alirezaafkar.sundatepicker.DatePicker;
import com.alirezaafkar.sundatepicker.interfaces.DateSetListener;
import com.example.mynotepad.MenuFeatures.AllNotes.AllNotesActivity;
import com.example.mynotepad.MenuFeatures.Calender.Date;
import com.example.mynotepad.MenuFeatures.AllNotes.NotesDataBase.DateEntity;
import com.example.mynotepad.R;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;

import java.util.Calendar;

import static com.example.mynotepad.MainActivity.noteDataBase;

public class DatePickerActivity extends AppCompatActivity {

    private DateEntity dateEntity;
    private TextView chosenDate, description;
    private Date mDate;
    private FloatingActionButton back;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_date_picker);
        init();
        showTimePicker();
    }

    private void init() {
        chosenDate = findViewById(R.id.chosenDate);
        description = findViewById(R.id.description);
        back = findViewById(R.id.calenderBackBtn);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                showAlert(view);
            }
        });
    }


    private void showTimePicker() {
        DatePicker.Builder builder = new DatePicker
                .Builder()
                .theme(R.style.DialogTheme)
                .future(true);
        mDate = new Date();
        builder.date(mDate.getDay(), mDate.getMonth(), mDate.getYear());
        builder.build(new DateSetListener() {
            @Override
            public void onDateSet(int id, @Nullable Calendar calendar, int day, int month, int year) {
                mDate.setDate(day, month, year);
                chosenDate.setText(mDate.getDate());
            }
        }).show(getSupportFragmentManager(), "");
    }

    private void showAlert(View view) {
        if (chosenDate.getText().length() != 0) {
            final AlertDialog.Builder alert = new AlertDialog.Builder(this);
            alert.setTitle("new note :");
            alert.setMessage("Do you want to save the note ?");
            alert.setCancelable(true);
            alert.setPositiveButton("yes", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialogInterface, int i) {
                    saveDateNote();
                    Toast.makeText(DatePickerActivity.this, "saved", Toast.LENGTH_SHORT).show();
                    finish();
                }
            });


            alert.setNegativeButton("no", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialogInterface, int i) {
                    dialogInterface.cancel();
                    finish();
                }
            });
            alert.show();
        } else if(description.getText().length() != 0){
            Snackbar.make(view, "note did not save ! you should pick a date ! ", Snackbar.LENGTH_LONG).setAction("Action", null).show();
            finish();
        }
        else{
            finish();
        }
    }

    private void saveDateNote() {
        //todo save in data base
        dateEntity = new DateEntity(chosenDate.getText().toString() , description.getText().toString() ,false);
        noteDataBase.dateNoreDAO().insertDateNote(dateEntity);
    }
}